#include "GenerateIndex.h"

static UBYTE ScrTitle[] = "GenerateIndex " VERSION " by Anders Melchiorsen";

struct TR_Dimensions RefDimensions, OptionsDimensions, ScanStatDimensions;

#define CheckBoxText(txt, id) VertGroup, HorizGroupSC, Space, CheckBox((id)), SpaceS, TextN((txt)), TRAT_ID, (id), Space, EndGroup, EndGroup

/// MainOutline
ProjectDefinition(MainOutline)
{
    WindowID(WINDOW_MAIN_ID),
	WindowPosition(TRWP_CENTERDISPLAY),
	WindowFlags(TRWF_HELP),
	WindowTitle("GenerateIndex"), 
	ScreenTitle(ScrTitle),
	WindowBackfillWin,

    BeginMenu("Project"),
	MenuItem("Clear", MAIN_MENU_PROJECT_CLEAR),
	ItemBarlabel,
	MenuItem("O_Open...", MAIN_MENU_PROJECT_LOAD),
	MenuItem("S_Save as...", MAIN_MENU_PROJECT_SAVE),
	ItemBarlabel,
	MenuItem("?_About...", MAIN_MENU_PROJECT_ABOUT),
	ItemBarlabel,
	MenuItem("Q_Quit", MAIN_MENU_PROJECT_QUIT),

    VertGroupA,

	Space,

	HorizGroupA,
	    Space,

	    GroupBox, ObjectBackfillB,
	    VertGroupA,

		Space,
		HorizGroupA,
		    Space,
		    ListSS(&FileList, MAIN_LIST_ID, 0, 0),
			TRAT_MinWidth,  30,
			TRAT_MinHeight, 10,
		    Space,
		EndGroup,

		SpaceS,

		HorizGroupAC,
		    Space,
		    TextN("References"),
		    SpaceS,
		    IntegerBox(0, MAIN_REFERENCES_ID, 3),
		    GetEntryButton(MAIN_OPENREFWINDOW_ID),
			TRAT_Flags, TRBU_RETURNOK,
		    Space,
		EndGroup,

		Space,

	    EndGroup,
	    Space,
	EndGroup,
	Space,

	HorizGroupE,
	    Space,
	    Button("_Scan...", MAIN_SCAN_ID),
	    Button("_Delete", MAIN_DELETE_ID),
	    Button("_Options...", MAIN_OPTIONS_ID),
	    Space,
	EndGroup,
	HorizGroupE,
	    Space,
	    Button("_Rescan", MAIN_RESCAN_ID),
	    Button("Rescan _all", MAIN_RESCANALL_ID),
	    Space,
	EndGroup,
	Space,

    EndGroup,
EndProject
};
///
/// RefOutline
ProjectDefinition(RefOutline)
{
    WindowID(WINDOW_REF_ID),
	WindowPosition(TRWP_CENTERDISPLAY),
	WindowFlags(TRWF_HELP),
	WindowTitle("References"),
	ScreenTitle(ScrTitle),
	WindowBackfillWin,
	WindowDimensions(&RefDimensions),

    VertGroupA,

	Space,

	HorizGroupA,
	    Space,

	    GroupBox, ObjectBackfillB,
	    VertGroupA,

		Space,

		HorizGroupA,
		    Space,
		    ListSS(NULL, REF_LIST_ID, 0, 0),
			TRAT_MinWidth,  30,
			TRAT_MinHeight, 10,
		    Space,
		EndGroup,

		SpaceS,

		HorizGroupA,
		    LineArray,

			Space,
			BeginLine,
			    Space,
			    TextNR("File"),
			    SpaceS,
			    ClippedTextBox("", REF_FILE_ID),
			    Space,
			EndLine,

			Space,
			BeginLine,
			    Space,
			    TextNR("Offset"),
			    SpaceS,

			    HorizGroupAC,
				IntegerBox(0, REF_OFFSET_ID, 6),
				Space,
				TextNR("Size"),
				SpaceS,
				IntegerBox(0, REF_LENGTH_ID, 6),
				Space,
			    EndGroup,
			EndLine,

			Space,
			BeginLine,
			    Space,
			    TextNR("Line"),
			    SpaceS,
			    IntegerBox(0, REF_GOTO_ID, 4),
			    Space,
			EndLine,
			Space,
		    EndArray,
		EndGroup,
	    EndGroup,

	    Space,
	EndGroup,

	Space,

	HorizGroupE,
	    Space,
	    Button("_Delete", REF_DELETE_ID),
	    Space,
	EndGroup,

	Space,

    EndGroup,

EndProject
};
///
/// OptionsOutline
ProjectDefinition(OptionsOutline)
{
    WindowID(WINDOW_OPTIONS_ID),
	WindowPosition(TRWP_CENTERDISPLAY),
	WindowTitle("Options"),
	ScreenTitle(ScrTitle),
	WindowBackfillWin,
	WindowFlags(TRWF_NOESCCLOSE|TRWF_HELP),
	WindowDimensions(&OptionsDimensions),

    BeginMenu("Settings"),
	MenuItem("O_Open...", OPTIONS_MENU_PROJECT_OPEN_ID),
	MenuItem("S_Save as...", OPTIONS_MENU_PROJECT_SAVEAS_ID),
	ItemBarlabel,
	MenuItem("L_Last saved", OPTIONS_MENU_PROJECT_LASTSAVED_ID),

    HorizGroupE,
	Space,

	VertGroupA,
	    Space,

	    GroupBox, ObjectBackfillB,
	    LineArray,
		Space,
		BeginLine,
		    Space,
		    CheckBoxText("Auto_Docs", OPTIONS_AUTODOC_ID),
		    Space,
		    CheckBoxText("_C includes", OPTIONS_C_ID),
		    Space,
		    CheckBoxText("_E includes", OPTIONS_E_ID),
		    Space,
		    CheckBoxText("_Asm includes", OPTIONS_ASM_ID),
		    Space,
		EndLine,

		Space,
		BeginLineI,
		    HorizSeparator,
		EndLine,

		Space,
		BeginLine,
		    Space,
		    HorizGroupS,
			Space,
		    EndGroup,
		    Space,
		    CheckBoxText("#define", OPTIONS_C_DEFINE_ID),
		    Space,
		    CheckBoxText("CONST", OPTIONS_E_CONST_ID),
		    Space,
		    CheckBoxText("EQU/BITDEF", OPTIONS_ASM_EQU_ID),
		    Space,
		EndLine,

		Space,
		BeginLine,
		    Space,
		    HorizGroupS,
			Space,
		    EndGroup,
		    Space,
		    CheckBoxText("struct/union", OPTIONS_C_STRUCT_ID),
		    Space,
		    CheckBoxText("OBJECT", OPTIONS_E_OBJECT_ID),
		    Space,
		    CheckBoxText("STRUCTURE", OPTIONS_ASM_STRUCTURE_ID),
		    Space,
		EndLine,

		Space,
		BeginLine,
		    Space,
		    HorizGroupS,
			Space,
		    EndGroup,
		    Space,
		    CheckBoxText("typedef", OPTIONS_C_TYPEDEF_ID),
		    Space,
		    CheckBoxText("PROC", OPTIONS_E_PROC_ID),
		    Space,
		    CheckBoxText("MACRO", OPTIONS_ASM_MACRO_ID),
		    Space,
		EndLine,

		Space,
	    EndArray,
	    Space,

	    GroupBox, ObjectBackfillB,
	    VertGroupA,
		Space,
		TRGR_Horiz, TRGR_ARRAY|TRGR_ALIGN|TRGR_CENTER|TRGR_PROPSPACES,
		    Space,
		    BeginColumn,
			HorizGroupC,
			    CheckBox(OPTIONS_RECURSIVELY_ID),
			    SpaceS,
			    HorizGroupS,
				TextID("Scan drawers _recursively", OPTIONS_RECURSIVELY_ID),
			    EndGroup,
			EndGroup,
			Space,
			HorizGroupC,
			    CheckBox(OPTIONS_KEEPEMPTY_ID),
			    SpaceS,
			    HorizGroupS,
				TextID("_Keep files without references", OPTIONS_KEEPEMPTY_ID),
			    EndGroup,
			EndGroup,
		    EndColumn,
		    Space,
		    BeginColumn,
			HorizGroupC,
			    CheckBox(OPTIONS_UNKNOWNASAUTODOC_ID),
			    SpaceS,
			    HorizGroupS,
				TextID("_Treat unrecognized files as Autodocs", OPTIONS_UNKNOWNASAUTODOC_ID),
			    EndGroup,
			EndGroup,
			Space,
			HorizGroupC,
			    Space,
			EndGroup,
		    EndColumn,
		    Space,
		EndArray,
		Space,
	    EndGroup,
	    Space,

	    HorizGroupE,
		Button("_Save", OPTIONS_SAVE_ID),
		Space,
		Button("_Use", OPTIONS_USE_ID),
		Space,
		ButtonE("Cancel", OPTIONS_CANCEL_ID),
	    EndGroup,
	    Space,

	EndGroup,
	Space,

    EndGroup,

EndProject
};
///
/// ScanStatOutline
ProjectDefinition(ScanStatOutline)
{
    WindowID(WINDOW_SCANSTAT_ID),
	WindowPosition(TRWP_CENTERDISPLAY),
	WindowTitle("Scanning..."),
	ScreenTitle(ScrTitle),
	WindowBackfillWin,
	WindowFlags(TRWF_NOESCCLOSE|TRWF_NOSIZEGADGET|TRWF_NOZIPGADGET|TRWF_HELP),
	WindowDimensions(&ScanStatDimensions),

    BeginMenu(""),
	MenuItem("You have discovered the secret menu", 0),

    HorizGroupA,
	Space,
	VertGroupA,
	    Space,
	    ButtonE("Stop", SCANSTAT_STOP_ID),
	    Space,
	EndGroup,
	Space,
    EndGroup,

EndProject
};
///

/// ReqTools stubs for varargs functions
LONG
rtChangeReqAttr(APTR req, ULONG Tag, ...)
{
    va_list args;

    va_start(args, req);
    return rtChangeReqAttrA(req, args);
}

ULONG
rtEZRequestTags(char *bodyfmt, char *gadfmt, struct rtReqInfo *reqinfo, APTR argarray, ULONG Tag, ...)
{
    va_list args;

    va_start(args, argarray);
    return rtEZRequestA(bodyfmt, gadfmt, reqinfo, argarray, args);
}

APTR
rtFileRequest(struct rtFileRequester *filereq, char *filename, char *title, ULONG Tag, ...)
{
    va_list args;

    va_start(args, title);
    return rtFileRequestA(filereq, filename, title, args);
}
///
